unit RTVDabou;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls {$ifdef WIN32}, Dialogs, ShellAPI {$endif};

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    OKButton: TBitBtn;
    ProgramIcon: TImage;
    LblProgName: TLabel;
    LblCopyright: TLabel;
    LblProgTitle: TLabel;
    LblAuthorEmail: TLabel;
    LblAuthorURL: TLabel;
    procedure LblAuthorEmailClick(Sender: TObject);
    procedure LblAuthorURLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

procedure TAboutBox.LblAuthorEmailClick(Sender: TObject);
var cmd: string;
begin
{$ifdef WIN32}
  cmd:= 'mailto:' + C_AuthorEmail +
        '?subject=' + 'About '+C_ProgIdn+' '+C_ProgVersion;
  if ShellExecute(GetDesktopWindow,nil,PChar(cmd),nil,nil,SW_NORMAL) <= 32
  then ShowMessage('failed to create e-mail');
{$endif}
end;

procedure TAboutBox.LblAuthorURLClick(Sender: TObject);
var cmd: string;
begin
{$ifdef WIN32}
  cmd:= C_AuthorURL;
  if ShellExecute(GetDesktopWindow,nil,PChar(cmd),nil,nil,SW_NORMAL) <= 32
  then ShowMessage('failed to launch web browser');
{$endif}
end;

end.

