unit Rtvdechn;

interface

uses
  RTVDTool, RTVDCAdd, RTVDCChg, RTVDCDel,
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Menus;

type
  TDlgChnList = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ChnList: TListBox;
    MainMenu: TMainMenu;
    MnuEdit: TMenuItem;
    MnuEditAdd: TMenuItem;
    MnuEditChg: TMenuItem;
    MnuEditDel: TMenuItem;
    PopupMenu: TPopupMenu;
    PopAdd: TMenuItem;
    PopChange: TMenuItem;
    PopDelete: TMenuItem;
    BitBtn1: TBitBtn;
    ToolBar: TPanel;
    BtnEditAdd: TSpeedButton;
    BtnEditChange: TSpeedButton;
    BtnEditDelete: TSpeedButton;
    procedure MnuEditAddClick(Sender: TObject);
    procedure MnuEditChgClick(Sender: TObject);
    procedure MnuEditDelClick(Sender: TObject);
    procedure MnuEditClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure ChnListClick(Sender: TObject);
  private
  public
    Changed : boolean;
    procedure AdjustToolbar;
  end;

var
  DlgChnList: TDlgChnList;

implementation
Uses StfLib;

{$R *.DFM}

procedure TDlgChnList.MnuEditAddClick(Sender: TObject);
var i: integer;
begin with DlgChnAdd, ChnList do begin
  TxtIdent.Text:= '';
  TxtDescr.Text:= '';
  ActiveControl:= TxtIdent;
  if (DlgChnAdd.ShowModal = mrOK) and
     (StfRTS(TxtIdent.Text) <> '') then begin
    i:= Items.Add(SetChnListItem(TxtIdent.Text,TxtDescr.Text));
    if  i > -1 then begin
      ItemIndex:= i;
      Changed:= true;
    end;
    AdjustToolbar;
  end;
end; end;

procedure TDlgChnList.MnuEditChgClick(Sender: TObject);
var i: integer;
begin with DlgChnChg, ChnList do if ItemIndex > -1 then begin
  TxtIdent.Text:= GetChnListIdent(Items[ItemIndex]);
  TxtDescr.Text:= StfRTS(GetChnListDescr(Items[ItemIndex]));
  ActiveControl:= TxtDescr;
  if (DlgChnChg.ShowModal = mrOK) and
     (StfRTS(TxtIdent.Text) <> '') then begin
    Items.Delete(ItemIndex);
    i:= Items.Add(SetChnListItem(TxtIdent.Text,TxtDescr.Text));
    if i > -1 then ChnList.ItemIndex:= i;
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TDlgChnList.MnuEditDelClick(Sender: TObject);
begin with DlgChnDel, ChnList do if ItemIndex > -1 then begin
  TxtIdent.Caption:= GetChnListIdent(Items[ItemIndex]);
  TxtDescr.Caption:= GetChnListDescr(Items[ItemIndex]);
  ActiveControl:= OKBtn;
  if DlgChnDel.ShowModal = mrOK then begin
    Items.Delete(ItemIndex);
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TDlgChnList.MnuEditClick(Sender: TObject);
begin
  MnuEditChg.Enabled:= ChnList.ItemIndex > -1;
  MnuEditDel.Enabled:= ChnList.ItemIndex > -1;
end;

procedure TDlgChnList.PopupMenuPopup(Sender: TObject);
begin
  PopChange.Enabled := ChnList.ItemIndex > -1;
  PopDelete.Enabled := ChnList.ItemIndex > -1;
end;

procedure TDlgChnList.AdjustToolbar;
begin
  BtnEditChange.Enabled:= ChnList.ItemIndex > -1;
  BtnEditDelete.Enabled:= ChnList.ItemIndex > -1;
end;

procedure TDlgChnList.ChnListClick(Sender: TObject);
begin AdjustToolbar; end;

end.
