unit RTVDmain;
{$B- Short-circuit Boolean expression evaluation}

interface

uses
  DefLib, StfLib, StpLib, NumLib,
  RTVDTool, RTVDAbou, RTVDEAdd, RTVDEChg, RTVDEDel, RTVDEChn, RTVDSDat,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls, Buttons, Printers, ClipBrd;

type
  TMainWnd = class(TForm)
    Toolbar: TPanel;
    ListBox: TListBox;
    StatusBar: TPanel;
    DlgFont: TFontDialog;
    MainMenu: TMainMenu;
    MnuFile: TMenuItem;
    MnuFileNew: TMenuItem;
    MnuFileOpen: TMenuItem;
    MnuFileSaveAs: TMenuItem;
    MnuFileSave: TMenuItem;
    MnuFilePrintSetup: TMenuItem;
    MnuFilePrint: TMenuItem;
    MnuFileExit: TMenuItem;
    MnuEdit: TMenuItem;
    MnuEditAdd: TMenuItem;
    MnuEditChange: TMenuItem;
    MnuEditDelete: TMenuItem;
    MnuEditCut: TMenuItem;
    MnuEditCopy: TMenuItem;
    MnuEditPaste: TMenuItem;
    MnuEditRepeat: TMenuItem;
    MnuEditChnList: TMenuItem;
    MnuSearch: TMenuItem;
    MnuSearchFind: TMenuItem;
    MnuSearchFindAgain: TMenuItem;
    MnuOptions: TMenuItem;
    MnuOptionsDuration: TMenuItem;
    MnuOptionsToolbar: TMenuItem;
    MnuOptionsHints: TMenuItem;
    MnuOptionsFont: TMenuItem;
    MnuHelp: TMenuItem;
    MnuHelpIndex: TMenuItem;
    MnuHelpGeneral: TMenuItem;
    MnuHelpMainData: TMenuItem;
    MnuHelpChnData: TMenuItem;
    MnuHelpAbout: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    BtnFileSave: TSpeedButton;
    BtnFilePrint: TSpeedButton;
    BtnFileExit: TSpeedButton;
    BtnEditAdd: TSpeedButton;
    BtnEditChange: TSpeedButton;
    BtnEditDelete: TSpeedButton;
    BtnEditCut: TSpeedButton;
    BtnEditCopy: TSpeedButton;
    BtnEditPaste: TSpeedButton;
    BtnEditRepeat: TSpeedButton;
    BtnEditChnList: TSpeedButton;
    BtnSearchFind: TSpeedButton;
    BtnSearchFindAgain: TSpeedButton;
    BtnHelpInfo: TSpeedButton;
    PopupMenu: TPopupMenu;
    PopAdd: TMenuItem;
    PopChange: TMenuItem;
    PopDelete: TMenuItem;
    PopChnList: TMenuItem;
    PopFind: TMenuItem;
    PopFindAgain: TMenuItem;
    DlgFileOpen: TOpenDialog;
    DlgFileSaveAs: TSaveDialog;
    DlgPrintSetup: TPrinterSetupDialog;
    DlgFilePrint: TPrintDialog;
    StatusState: TPanel;
    StatusFilename: TPanel;
    CopyBuffer: TEdit;
    procedure MnuFileClick(Sender: TObject);
    procedure MnuFileNewClick(Sender: TObject);
    procedure MnuFileOpenClick(Sender: TObject);
    procedure MnuFileSaveClick(Sender: TObject);
    procedure MnuFileSaveAsClick(Sender: TObject);
    procedure MnuFilePrintSetupClick(Sender: TObject);
    procedure MnuFilePrintClick(Sender: TObject);
    procedure MnuFileExitClick(Sender: TObject);
    procedure MnuEditClick(Sender: TObject);
    procedure MnuEditAddClick(Sender: TObject);
    procedure MnuEditChangeClick(Sender: TObject);
    procedure MnuEditDeleteClick(Sender: TObject);
    procedure MnuEditCutClick(Sender: TObject);
    procedure MnuEditCopyClick(Sender: TObject);
    procedure MnuEditPasteClick(Sender: TObject);
    procedure MnuEditRepeatClick(Sender: TObject);
    procedure MnuEditChnListClick(Sender: TObject);
    procedure MnuSearchClick(Sender: TObject);
    procedure MnuSearchFindClick(Sender: TObject);
    procedure MnuSearchFindAgainClick(Sender: TObject);
    procedure MnuOptionsDurationClick(Sender: TObject);
    procedure MnuOptionsToolbarClick(Sender: TObject);
    procedure MnuOptionsHintsClick(Sender: TObject);
    procedure MnuOptionsFontClick(Sender: TObject);
    procedure MnuHelpClick(Sender: TObject);
    procedure MnuHelpAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure ListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PopupMenuPopup(Sender: TObject);
    procedure ListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DlgFontApply(Sender: TObject; Wnd: Word);
  private
  public
    Status    : T_State;
    Options   : T_Options;
    ChnList   : TStringList;
    Changed   : boolean;
    FindDateStr: String[10];
    procedure GetPosition;
    procedure SetPosition;
    function  SetStatus(V_State: T_State): T_State;
    procedure ApplyOptions;
    function  ReadChnList(V_FileName: TFileName): boolean;
    function  SaveChnList(V_FileName: TFileName): boolean;
    function  OKtoClose: boolean;
    function  FileOpen: boolean;
    function  FileSave: boolean;
    function  FileSaveAs: boolean;
    function  DoFileSave: boolean;
    function  AddItem(V_Item: StpTyp): boolean;
    procedure DoCut;
    procedure DoCopy;
    procedure DoDelete;
    procedure DoPaste;
    procedure DoRepeat;
    function  EnablePrint: boolean;
    function  EnableChange: boolean;
    function  EnableDelete: boolean;
    function  EnableCut: boolean;
    function  EnableCopy: boolean;
    function  EnablePaste: boolean;
    function  EnableRepeat: boolean;
    function  EnableFind: boolean;
    function  EnableFindAgain: boolean;
    procedure AdjustToolbar;
    procedure ApplyFont;
  end;

var
  MainWnd: TMainWnd;

implementation

{$R *.DFM}

procedure TMainWnd.MnuFileClick(Sender: TObject);
begin MnuFilePrint.Enabled := EnablePrint; end;

procedure TMainWnd.MnuFileNewClick(Sender: TObject);
begin if OKtoClose then begin
  ChnList.Clear;
  ListBox.Clear;
  Changed:= false;
  Options.FileName:= '';
  SetStatus(St_Edit);
  ApplyOptions;
end; end;

procedure TMainWnd.MnuFileOpenClick(Sender: TObject);
begin
  DlgFileOpen.FileName:= Options.FileName;
  if DlgFileOpen.Execute then begin
    Options.FileName:= DlgFileOpen.FileName;
    FileOpen;
    AdjustToolbar;
  end;
end;

procedure TMainWnd.MnuFileSaveClick(Sender: TObject);
begin FileSave; AdjustToolbar; end;

procedure TMainWnd.MnuFileSaveAsClick(Sender: TObject);
begin FileSaveAs; AdjustToolbar; end;

procedure TMainWnd.MnuFilePrintSetupClick(Sender: TObject);
var OldStatus: T_State;
begin
  OldStatus:= SetStatus(St_PrSet);
  DlgPrintSetup.Execute;
  SetStatus(OldStatus);
end;

procedure TMainWnd.MnuFilePrintClick(Sender: TObject);
var i: integer; F: TextFile; OldStatus: T_State;
begin if EnablePrint then begin
  Screen.Cursor:= crHourGlass;
  OldStatus:= SetStatus(St_Print);
  try
    AssignPrn(F); Rewrite(F);
    try
      Printer.Canvas.Font:= ListBox.Font;
      for i:= 0 to ListBox.Items.Count - 1 do WriteLn(F,
        C_PrnMargin+DisplayStp(ListBox.Items[i],Options.OptDuration));
    finally
      CloseFile(F);
    end;
  finally
    SetStatus(OldStatus);
    Screen.Cursor:= crDefault;
  end;
end; end;

procedure TMainWnd.MnuFileExitClick(Sender: TObject);
begin Close; end;

procedure TMainWnd.MnuEditClick(Sender: TObject);
begin
  MnuEditChange.Enabled := EnableChange;
  MnuEditDelete.Enabled := EnableDelete;
  MnuEditCut.Enabled    := EnableCut;
  MnuEditCopy.Enabled   := EnableCopy;
  MnuEditPaste.Enabled  := EnablePaste;
  MnuEditRepeat.Enabled := EnableRepeat;
end;

procedure TMainWnd.MnuEditAddClick(Sender: TObject);
  function DialogOk: boolean;
  var rc: integer;
  begin with DlgAdd do begin
    rc:= DlgAdd.ShowModal;
    while (rc = mrOK) and
          ( StpEmpty(StfRLS(TxtDate.Text)) or
            StpEmpty(StfRLS(TxtTitle.Text)) )
    do begin
      MessageDlg('Need non-empty Date and Title fields',mtError,[mbOK],0);
      rc:= DlgAdd.ShowModal;
    end;
    DialogOk:= rc = mrOK;
  end; end;
begin with DlgAdd,ListBox do begin
  TxtDate.Text          := StfNCpy(GV_CurDate,5);
  TxtTimeFrom.Text      := '';
  TxtTimeTo.Text        := '';
  TxtChannel.Items      := ChnList;
  TxtChannel.ItemIndex  := -1;
  TxtTitle.Text         := '';
  BtnRecYes.Checked     := false;
  BtnRecNo.Checked      := false;
  BtnRecNeutral.Checked := true;
  ActiveControl         := TxtDate;
  if DialogOK then begin
    if AddItem(SetListItem(
      StfRLS(TxtDate.Text),
      StfRLS(TxtTimeFrom.Text),
      StfRLS(TxtTimeTo.Text),
      GetChnListIdent(StfUpp(StfRLS(TxtChannel.Text))),
      GetRecCode(BtnRecYes.Checked,BtnRecNo.Checked,BtnRecNeutral.Checked),
      StfRLS(TxtTitle.Text)))
    then AdjustToolbar;
  end;
end; end;

procedure TMainWnd.MnuEditChangeClick(Sender: TObject);
var RecCode: string[1];
  function DialogOk: boolean;
  var rc: integer;
  begin with DlgChange do begin
    rc:= DlgChange.ShowModal;
    while (rc = mrOK) and
          ( StpEmpty(StfRLS(TxtDate.Text)) or
            StpEmpty(StfRLS(TxtTitle.Text)) )
    do begin
      MessageDlg('Need non-empty Date and Title fields',mtError,[mbOK],0);
      rc:= DlgChange.ShowModal;
    end;
    DialogOk:= rc = mrOK;
  end; end;
begin if EnableChange then with DlgChange,ListBox do begin
  TxtDate.Text          := StfRTS(GetListDate(Items[ItemIndex]));
  TxtTimeFrom.Text      := StfRTS(GetListTimeFrom(Items[ItemIndex]));
  TxtTimeTo.Text        := StfRTS(GetListTimeTo(Items[ItemIndex]));
  TxtDuration.Text      := Duration(TxtTimeFrom.Text,TxtTimeTo.Text);
  TxtChannel.Items      := ChnList;
  TxtChannel.ItemIndex  :=
    ChnList.IndexOf(FullChnStp(GetListChn(Items[ItemIndex]),ChnList));
  TxtTitle.Text         := StfRTS(GetListTitle(Items[ItemIndex]));
  RecCode:= GetListRec(Items[ItemIndex]);
  BtnRecYes.Checked     := RecCode = '+';
  BtnRecNo.Checked      := RecCode = '-';
  BtnRecNeutral.Checked := (RecCode <> '+') and (RecCode <> '-');
  ActiveControl         := TxtDate;
  if DialogOk then begin
    Items.Delete(ItemIndex);
    AddItem(SetListItem(
      StfRLS(TxtDate.Text),
      StfRLS(TxtTimeFrom.Text),
      StfRLS(TxtTimeTo.Text),
      GetChnListIdent(StfUpp(StfRLS(TxtChannel.Text))),
      GetRecCode(BtnRecYes.Checked,BtnRecNo.Checked,BtnRecNeutral.Checked),
      StfRLS(TxtTitle.Text)));
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.MnuEditDeleteClick(Sender: TObject);
var RecCode: string[1];
begin if EnableDelete then with DlgDelete,ListBox do begin
  TxtDate.Text          := StfRTS(GetListDate(Items[ItemIndex]));
  TxtTimeFrom.Text      := StfRTS(GetListTimeFrom(Items[ItemIndex]));
  TxtTimeTo.Text        := StfRTS(GetListTimeTo(Items[ItemIndex]));
  TxtDuration.Text      := Duration(TxtTimeFrom.Text,TxtTimeTo.Text);
  TxtChannel.Text       := FullChnStp(GetListChn(Items[ItemIndex]),ChnList);
  TxtTitle.Text         := StfRTS(GetListTitle(Items[ItemIndex]));
  RecCode               := GetListRec(Items[ItemIndex]);
  BtnRecYes.Checked     := RecCode = '+';
  BtnRecNo.Checked      := RecCode = '-';
  BtnRecNeutral.Checked := (RecCode <> '+') and (RecCode <> '-');
  if DlgDelete.ShowModal = mrOK then
    DoDelete;
end; end;

procedure TMainWnd.MnuEditCutClick(Sender: TObject);
begin DoCut; end;

procedure TMainWnd.MnuEditCopyClick(Sender: TObject);
begin DoCopy; end;

procedure TMainWnd.MnuEditPasteClick(Sender: TObject);
begin DoPaste; end;

procedure TMainWnd.MnuEditRepeatClick(Sender: TObject);
begin DoRepeat; end;

procedure TMainWnd.MnuEditChnListClick(Sender: TObject);
begin
  DlgChnList.ChnList.Items.Clear;
  DlgChnList.ChnList.Items.Assign(ChnList);
  DlgChnList.ToolBar.ShowHint:= Options.OptHints;
  DlgChnList.Changed:= false;
  DlgChnList.AdjustToolbar;
  DlgChnList.ActiveControl:= DlgChnList.ChnList;
  if (DlgChnList.ShowModal = mrOK) and DlgChnList.Changed then begin
    ChnList.Clear;
    ChnList.Assign(DlgChnList.ChnList.Items);
    DlgChnList.ChnList.Items.Clear;
    Changed:= true;
    ListBox.Refresh;
    AdjustToolbar;
  end;
end;

procedure TMainWnd.MnuSearchClick(Sender: TObject);
begin
  MnuSearchFind.Enabled      := EnableFind;
  MnuSearchFindAgain.Enabled := EnableFindAgain;
end;

procedure TMainWnd.MnuSearchFindClick(Sender: TObject);
var i: integer; ok: boolean; OldStatus: T_State;
begin if EnableFind then with DlgFindDate do begin
  TxtDate.Text:= FindDateStr;
  ActiveControl:= TxtDate;
  if (DlgFindDate.ShowModal = mrOK) and
     (StfSub(TxtDate.Text,1,4) <> '    ')
  then begin
    FindDateStr:= StfRTS(TxtDate.Text);
    with ListBox do begin
      OldStatus:= SetStatus(St_Find);
      i:= -1; ok:= false;
      while (not ok) and (i < Items.Count - 1) do begin
        Inc(i); ok:= Items[i] >= FindDateStr;
      end;
      ItemIndex:= i;
      SetStatus(OldStatus);
    end;
  end;
  AdjustToolbar;
end; end;

procedure TMainWnd.MnuSearchFindAgainClick(Sender: TObject);
var i: integer; n: StpInd; found: boolean; OldStatus: T_State;
begin if EnableFindAgain then with ListBox do begin
  OldStatus:= SetStatus(St_Find);
  i:= ItemIndex; n:= StpLen(FindDateStr); found:= false;
  while (not found) and (i < Items.Count - 1) do begin
    Inc(i); found:= StpNCmp(Items[i],FindDateStr,n) = 0;
  end;
  SetStatus(OldStatus);
  if found then ItemIndex:= i
  else MessageDlg(
    'No entries matching'#13+FindDateStr+#13'after current row',
    mtInformation,[mbOk],0);
  AdjustToolbar;
end; end;

procedure TMainWnd.MnuOptionsDurationClick(Sender: TObject);
begin with Options do begin
  OptDuration:= not OptDuration;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsToolbarClick(Sender: TObject);
begin with Options do begin
  OptToolbar:= not OptToolbar;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsHintsClick(Sender: TObject);
begin with Options do begin
  OptHints:= not OptHints;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsFontClick(Sender: TObject);
begin
  DlgFont.Font:= ListBox.Font;
  if DlgFont.Execute then begin
    ListBox.Font:= DlgFont.Font;
    ApplyOptions;
  end;
end;

procedure TMainWnd.MnuHelpClick(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
  if      Sender = MnuHelpGeneral then
    Application.HelpCommand(HELP_CONTEXT,HC_General)
  else if Sender = MnuHelpMainData then
    Application.HelpCommand(HELP_CONTEXT,HC_MainData)
  else if Sender = MnuHelpChnData then
    Application.HelpCommand(HELP_CONTEXT,HC_ChnData)
  else
    Application.HelpCommand(HELP_CONTENTS, 0);
  Screen.Cursor:= crDefault;
end;

procedure TMainWnd.MnuHelpAboutClick(Sender: TObject);
begin
  with AboutBox do begin
    Caption                := 'About this program';
    LblProgName.Caption    := C_ProgIdn+' '+C_ProgVersion;
    LblProgTitle.Caption   := C_ProgTitle;
    LblCopyRight.Caption   := C_CopyRight;
    LblAuthorEmail.Caption := C_AuthorEmail;
    LblAuthorURL.Caption   := C_AuthorURL;
   {$ifdef WIN32}
    with LblAuthorEmail.Font do begin
      Color:= clBlue;
      Style:= Style + [fsUnderline];
    end;
    with LblAuthorURL.Font do begin
      Color:= clBlue;
      Style:= Style + [fsUnderline];
    end;
   {$endif}
  end;
  AboutBox.ShowModal;
end;

procedure TMainWnd.FormCreate(Sender: TObject);
begin
  GV_ProgIdn    :=
    StfUpp(StfBefore(ExtractFileName(Application.ExeName),'.'));
  GV_SettingFnm := ChangeFileExt(Application.ExeName,C_IniFileExt);
  GetCurDate;
  ChnList:= TStringList.Create;
  ChnList.Sorted:= true;
  Options:= C_DflOptions;
  SetStatus(St_None);
  ReadOptions(Options);
  GetPosition;
  Changed:= false;
  FindDateStr:= '';
  FileOpen;
  ApplyOptions;
end;

procedure TMainWnd.GetPosition;
begin with Options do begin
  Top    := WndTop;
  Left   := WndLeft;
  Height := WndHeight;
  Width  := WndWidth;
end; end;

procedure TMainWnd.SetPosition;
begin with Options do begin
  WndTop    := Top;
  WndLeft   := Left;
  WndHeight := Height;
  WndWidth  := Width;
end; end;

function  TMainWnd.SetStatus(V_State: T_State): T_State;
begin
  StatusState.Caption    := C_StateTxt[V_State];
  StatusFileName.Caption := StfUpp(Options.FileName);
  StatusBar.Refresh;
  SetStatus := Status;
  Status    := V_State;
end;

procedure TMainWnd.ApplyOptions;
begin with Options do begin
  MnuOptionsDuration.Checked:= OptDuration;
  MnuOptionsToolbar.Checked := OptToolbar;
  MnuOptionsHints.Checked   := OptHints;
  Toolbar.Visible           := OptToolbar;
  MainWnd.ShowHint          := OptHints;
  ListBox.ItemHeight        := - ListBox.Font.Height;
  ListBox.Refresh;
  AdjustToolbar;
end; end;

function  TMainWnd.OKtoClose: boolean;
var ok: boolean;
begin
  ok:= true;
  if Changed then begin
    case MessageDlg('Save changes?',mtConfirmation,mbYesNoCancel,0) of
      mrYes    : ok:= FileSave;
      mrNo     : ;
      mrCancel : ok:= false;
      else       ok:= false;
    end;
  end;
  OKtoClose:= ok;
end;

function  TMainWnd.FileOpen: boolean;
var ok: boolean;
begin
  ok:= false;
  if Options.FileName <> '' then begin
    Screen.Cursor:= crHourGlass;
    SetStatus(St_Read);
    try
      if not ReadChnList(Options.FileName) then ChnList.Clear;
      ListBox.Clear;
      ListBox.Items.LoadFromFile(Options.FileName);
      Changed:= false;
      ApplyOptions;
      ok:= true;
    finally
      SetStatus(St_Edit);
      Screen.Cursor:= crDefault;
    end;
  end;
  FileOpen:= ok;
end;

function  TMainWnd.FileSave: boolean;
begin
  if Options.FileName = '' then
    FileSave:= FileSaveAs
  else
    FileSave:= DoFileSave;
end;

function  TMainWnd.FileSaveAs: boolean;
var ok: boolean;
begin
  ok:= false;
  DlgFileSaveAs.FileName:= Options.FileName;
  if DlgFileSaveAs.Execute and (Options.FileName <> '') then begin
    Options.FileName:= DlgFileSaveAs.FileName;
    ApplyOptions;
    ok:= DoFileSave;
  end;
  FileSaveAs:= ok;
end;

function  TMainWnd.DoFileSave: boolean;
var ok: boolean; OldStatus: T_State;
begin
  ok:= false;
  if Options.FileName <> '' then begin
    Screen.Cursor:= crHourGlass;
    OldStatus:= SetStatus(St_Save);
    try
      SaveChnList(Options.FileName);
      ListBox.Items.SaveToFile(Options.FileName);
      Changed:= false;
      ok:= true;
    finally
      SetStatus(OldStatus);
      Screen.Cursor:= crDefault;
    end;
  end;
  if not ok then MessageDlg(
    'Unable to save file'#13+Options.FileName,mtError,[mbOK],0);
  DoFileSave:= ok;
end;

function TMainWnd.ReadChnList(V_FileName: TFileName): boolean;
var ok: boolean; ChnFnm: TFileName; F: TextFile;
begin
  ok:= false;
  ChnFnm:= ChangeFileExt(V_FileName,C_ChnFileExt);
  AssignFile(F,ChnFnm); {$I-} Reset(F); {$I+}
  if IOResult = 0 then begin
    CloseFile(F);
    ChnList.Clear;
    ChnList.LoadFromFile(ChnFnm);
    ok:= true;
  end;
  ReadChnList:= ok;
end;

function TMainWnd.SaveChnList(V_FileName: TFileName): boolean;
var ok: boolean; ChnFnm: TFileName;
begin
  ok:= false;
  try
    ChnFnm:= ChangeFileExt(V_FileName,C_ChnFileExt);
    ChnList.SaveToFile(ChnFnm);
    ok:= true;
  finally
    SaveChnList:= ok;
  end;
end;

function  TMainWnd.AddItem(V_Item: StpTyp): boolean;
var i: integer;
begin with ListBox do begin
  i:= Items.Add(V_Item);
  if i < 0  then AddItem:= false
  else begin ItemIndex:= i; Changed:= true; AddItem:= true; end;
end; end;

procedure TMainWnd.DoCut;
begin if EnableCopy then with ListBox,Items do begin
  CopyBuffer.Text:= C_ClipTag+Items[ItemIndex];
  CopyBuffer.SelectAll;
  CopyBuffer.CopyToClipboard;
  DoDelete;
end end;

procedure TMainWnd.DoCopy;
begin if EnableCopy then with ListBox,Items do begin
  CopyBuffer.Text:= C_ClipTag+Items[ItemIndex];
  CopyBuffer.SelectAll;
  CopyBuffer.CopyToClipboard;
end end;

procedure TMainWnd.DoDelete;
var i: integer;
begin with ListBox,Items do begin
  i:= ItemIndex;
  Items.Delete(i);
  Itemindex:= IMin(i,Count-1);
  Changed:= true;
  AdjustToolbar;
end; end;

procedure TMainWnd.DoPaste;
begin if EnablePaste then begin
  CopyBuffer.SelectAll;
  CopyBuffer.PasteFromClipboard;
  if AddItem(StfSub(CopyBuffer.Text,StpLen(C_ClipTag)+1,MaxStp)) then
    AdjustToolbar;
end; end;

procedure TMainWnd.DoRepeat;
begin if EnableRepeat then with ListBox do begin
  if AddItem(Items[ItemIndex]) then AdjustToolbar;
end; end;

procedure TMainWnd.ListBoxClick(Sender: TObject);
begin AdjustToolbar; end;

procedure TMainWnd.ListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin with (Control as TListBox),Canvas do begin
  FillRect(Rect);
  TextOut(Rect.Left, Rect.Top, DisplayStp(Items[Index],Options.OptDuration));
end; end;

procedure TMainWnd.FormDestroy(Sender: TObject);
begin ChnList.Free; end;

procedure TMainWnd.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin CanClose:= OKtoClose; end;

procedure TMainWnd.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetPosition;
  WriteOptions(Options);
  Application.HelpCommand(HELP_QUIT, 0);
end;

procedure TMainWnd.PopupMenuPopup(Sender: TObject);
begin
  PopChange.Enabled    := EnableChange;
  PopDelete.Enabled    := EnableDelete;
  PopFind.Enabled      := EnableFind;
  PopFindAgain.Enabled := EnableFindAgain;
end;

procedure TMainWnd.AdjustToolbar;
begin
  BtnFilePrint.Enabled       := EnablePrint;
  BtnEditChange.Enabled      := EnableChange;
  BtnEditDelete.Enabled      := EnableDelete;
  BtnEditCut.Enabled         := EnableCut;
  BtnEditCopy.Enabled        := EnableCopy;
  BtnEditPaste.Enabled       := EnablePaste;
  BtnEditRepeat.Enabled      := EnableRepeat;
  BtnSearchFind.Enabled      := EnableFind;
  BtnSearchFindAgain.Enabled := EnableFindAgain;
end;

function TMainWnd.EnablePrint: boolean;
begin EnablePrint:= ListBox.Items.Count > 0; end;

function TMainWnd.EnableChange: boolean;
begin EnableChange:= ListBox.ItemIndex > -1; end;

function TMainWnd.EnableDelete: boolean;
begin EnableDelete:= ListBox.ItemIndex > -1; end;

function TMainWnd.EnableCut: boolean;
begin with ListBox do begin
  EnableCut:= (ItemIndex>=0) and Selected[ItemIndex];
end; end;

function TMainWnd.EnableCopy: boolean;
begin with ListBox do begin
  EnableCopy:= (ItemIndex>=0) and Selected[ItemIndex];
end; end;

function TMainWnd.EnableRepeat: boolean;
begin with ListBox do begin
  EnableRepeat:= (ItemIndex>=0) and Selected[ItemIndex];
end; end;

function TMainWnd.EnablePaste: boolean;
begin
  EnablePaste:=
    ClipBoard.HasFormat(CF_TEXT) and
    (StpNCmp(ClipBoard.AsText,C_ClipTag,3) = 0);
end;

function TMainWnd.EnableFind: boolean;
begin EnableFind:= ListBox.Items.Count > 0; end;

function TMainWnd.EnableFindAgain: boolean;
begin
  EnableFindAgain:= (ListBox.Items.Count > 0) and (FindDateStr <> '');
end;

procedure TMainWnd.ListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin case Key of
  VK_DELETE: if      Shift = [ssShift] then DoCut;
  VK_INSERT: if      Shift = [ssCtrl ] then DoCopy
             else if Shift = [ssShift] then DoPaste;
end; end;

procedure TMainWnd.ApplyFont;
begin
  ListBox.Font:= DlgFont.Font;
  ApplyOptions;
end;

procedure TMainWnd.DlgFontApply(Sender: TObject; Wnd: Word);
begin
  ApplyFont;
end;

end.
